--[[	
Title: myBigIgnite
Addon version: 1.4.3
Game version: 4.0.6
Author: Istaran | Medivh - EU
Pieces of code from IgniteTracker by Siffin (Korgath US).
myBigIgnite	is licensed under Creative Commons Attribution - No Commercial Use 3.0. myBigIgnite est sous licence Creative Commons Paternit - Pas d'Utilisation Commerciale 3.0. See: http://creativecommons.org/licenses/by-nc/3.0/
]]



if (select(2, UnitClass("player")) ~= "MAGE") then
   return
end

local myBigIgnite = LibStub("AceAddon-3.0"):NewAddon("myBigIgnite", "AceConsole-3.0", "AceEvent-3.0")
local mBI = myBigIgnite

mBI.dotForCombu = {}

local mBIrefresh = 0.1
local remainTime = {}
local spellenabled = {}
local spellname = {}

local mBIversion = "1.4.3"






-- Create Default Database
mBI.defaults = {
	["global"] = {
		["mainFrame"] = {
			["position"] = {
				["POINT"] = "CENTER",
				["PARENT"] = "UIParent",
				["RELATIVE"] = "CENTER",
				["XCOORD"] = 0,
				["YCOORD"] = 0,
			},
			["movable"] = true,		
		},
		["spellAura"] = {
			["ignite"] = {
				["enabled"] = true,
				["dotCombu"] = true,
				["locname"]= "Ignite",
				["id"] = 12654,
			},
			["livingBomb"] = {
				["enabled"] = true,
				["dotCombu"] = true,
				["locname"]= "Living Bomb",
				["id"] = 44457,
			},
			["pyroblast"] = {
				["enabled"] = false,
				["dotCombu"] = true,
				["locname"]= "Pyroblast",
				["id"] = 11366,
			},
			["pyroHS"] = {
				["enabled"] = false,
				["dotCombu"] = true,
				["locname"]= "Pyroblast!",
				["id"] = 92315,
			},
			["ffbolt"] = {
				["enabled"] = false,
				["dotCombu"] = true,
				["locname"]= "Frostfire Bolt",
				["id"] = 44614,
			},
			["combustion"] = {
				["enabled"] = true,
				["CDtracking"] = true,
				["dotCombu"] = false,
				["locname"]= "Combustion",
				["id"] = 83853,
			},
		},
		["noIgHide"] = false,
		["igValue"] = 0,
		["igPerct"] = 0.75,
		["lag"] = 0.5,
		["locale"] = "enGB",
	},
}


function myBigIgnite:LocalCheck()
	local locale = GetCVar("locale")
	if (locale ~= "enGB" and mBI.db.global.locale == "enGB") then
		for k1, v1 in pairs(mBI.db.global.spellAura) do
			for k2, v2 in pairs(v1) do
				if (k2 == "id") then
					mBI.db.global.spellAura[k1].locname = GetSpellInfo(v2)
				end
			end
		end
		mBI.db.global.locale = locale
	elseif (locale == "enGB" and mBI.db.global.locale ~= "enGB") then
		for k1, v1 in pairs(mBI.db.global.spellAura) do
			mBI.db.global.spellAura[k1].locname = mBI.defaults.global.spellAura[k1].locname
		end
		mBI.db.global.locale = locale
	end
end		


function myBigIgnite:SpecCheck(event, ...)
	if not mBI.firstCheck then
		mBI.firstCheck = true
		return
	else
		if IsSpellKnown(11129) then
			if not mBI.specFire then
				myBigIgnite:mBILoad()
				mBI.specFire = true
			end
		else
			if mBI.specFire then
				self:UnregisterEvent("PLAYER_REGEN_DISABLED")
				self:UnregisterEvent("PLAYER_LEAVE_COMBAT")
				self:UnregisterEvent("PLAYER_REGEN_ENABLED")
				self:UnregisterChatCommand("myBigIgnite")
				self:UnregisterChatCommand("mbi")
				mBIframe:Hide()
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite is deactivated")
				mBI.specFire = false
			end
		end 
		mBI.firstCheck = false
	end
end

--When the addon becomes enabled, create the frame, and register the combat log event
function myBigIgnite:OnEnable()
	mBI.firstCheck = true
	self:RegisterEvent("PLAYER_TALENT_UPDATE", "SpecCheck")
end
	
	
function myBigIgnite:mBILoad()
	mBI.spellcount = 0
	mBI.combuCD = false
	
	self.db = LibStub("AceDB-3.0"):New("mBIsettings", mBI.defaults)
	self:RegisterChatCommand("myBigIgnite","SlashCommand")
	self:RegisterChatCommand("mbi","SlashCommand")
	myBigIgnite:LocalCheck()
	self:CreateFrame()
	self:RegisterEvent("PLAYER_REGEN_DISABLED","CombatCheck")
	self:RegisterEvent("PLAYER_REGEN_ENABLED","CombatCheck")
	mBIframe:SetScript("OnEvent", function(self,event,...) mBIEvents[event](self,...) end)
	for k,v in pairs(mBIEvents) do
	    mBIframe:RegisterEvent(k)
	end
	mBIfcombat:SetScript("OnUpdate",  function(self, elapsed) myBigIgnite.OnUpdate(self, elapsed) end)
	
	local i = 1
	for k1, v1 in pairs(mBI.db.global.spellAura) do
		for k2, v2 in pairs(v1) do
			if (k2 == "enabled") then
				spellenabled[i] = v2
			elseif (k2 == "locname") then
				spellname[i] = v2
			elseif (k2 == "dotCombu") then
				mBI.dotForCombu[i] = v2
			end
		end
		if spellenabled[i] and mBI.dotForCombu[i] then
			if string.find(k1, "pyro") then
				mBI.spellcount = mBI.spellcount + 0.5
				else
				mBI.spellcount = mBI.spellcount + 1
			end
		end
	i = i + 1	
	end
	
	mBI.lag = tonumber(mBI.db.global.lag)
	
	local _, durationCD, _ = GetSpellCooldown(mBI.db.global.spellAura.combustion.locname)
	if durationCD >	2 then
		mBI.combuCD = true
		mBI.combuCDdelay = 0.5
		mBIfcombat:Show()
	end
end




--Options
function myBigIgnite:SlashCommand(arg)
	t = {}
	c = 0
	for token in string.gmatch(arg, "[^%s]+") do
		t[c] = token
		c = c+1
	end
	if t[0] == "reset" then
			mBI.db.global.mainFrame.position = "CENTER","UIParent","CENTER",0,0
			mBI.db.global.mainFrame.movable = true
			mBI.db.global.noIgHide = false
			mBI.db.global.igValue = 0
			mBI.db.global.igPerct = 0.75
			mBIframe:SetPoint(mBI.db.global.mainFrame.position)
			mBIframe.text:Show()
			mBI.db.global.spellAura = mBI.defaults.global.spellAura
			myBigIgnite:MoveFrame()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680myBigIgnite has been reset")
	elseif t[0] == "frame" then
		if t[1] == "unlock" then
			mBI.db.global.mainFrame.movable = true
			myBigIgnite:MoveFrame()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Display frame unlocked")
		elseif t[1] == "lock" then
			mBI.db.global.mainFrame.movable = false
			myBigIgnite:MoveFrame()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Display frame locked")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite \"/mbi frame\" options:")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680lock - locks the frame")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680unlock - unlocks the frame")
		end
	
	elseif t[0] == "value" then
		if t[1] == "set" then
			mBI.db.global.igValue = t[2]
			mBIwarning = false
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Optimal ignite tick value set to " .. t[2])
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Intermediate ignite tick value set to " .. tonumber(mBI.db.global.igValue)*tonumber(mBI.db.global.igPerct))
		elseif t[1] == "percent" then
			mBI.db.global.igPerct = tonumber(t[2])/100
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Percentage of optimal ignite tick value set to " .. t[2])
		elseif t[1] == "print" then
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Optimal ignite tick value set to " .. mBI.db.global.igValue)
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Percentage of optimal ignite tick value set to " .. tonumber(mBI.db.global.igPerct)*100 .. "%")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Good ignite tick value is " .. tonumber(mBI.db.global.igValue)*tonumber(mBI.db.global.igPerct))
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite \"/mbi value\" options:")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680set ##### - sets the value of an optimal ignite tick to #####")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680percent ## - sets the percentage used to calculate a good value for an ignite tick to ##")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680print - prints the settings")
		end
	
	elseif t[0] == "hide" then
		if t[1] == "auto" then
			mBI.db.global.noIgHide = true
			mBIframe.text:Hide()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Autohide is enabled")
		elseif t[1] == "never" then
			mBI.db.global.noIgHide = false
			mBIframe.text:Show()
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Autohide is disabled")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680auto - myBigIgnite is automatically hidden when no ignite is present on the target")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680never - myBigIgnite is always shown")
		end
	
	elseif t[0] == "spell" then
		if t[1] == "lb" then
			if mBI.db.global.spellAura.livingBomb.enabled then
				mBI.db.global.spellAura.livingBomb.enabled = false
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Living Bomb tracking is disabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			else
				mBI.db.global.spellAura.livingBomb.enabled = true
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Living Bomb tracking is enabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			end
		elseif t[1] == "pyro" then
			if mBI.db.global.spellAura.pyroblast.enabled then
				mBI.db.global.spellAura.pyroblast.enabled = false
				mBI.db.global.spellAura.pyroHS.enabled = false
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Pyroblast tracking is disabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			else
				mBI.db.global.spellAura.pyroblast.enabled = true
				mBI.db.global.spellAura.pyroHS.enabled = true
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Pyroblast tracking is enabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			end
		elseif t[1] == "ffb" then
			if mBI.db.global.spellAura.ffbolt.enabled then
				mBI.db.global.spellAura.ffbolt.enabled = false
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Frostfire Bolt tracking is disabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			else
				mBI.db.global.spellAura.ffbolt.enabled = true
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Frostfire Bolt tracking is enabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			end
		elseif t[1] == "combu" then
			if mBI.db.global.spellAura.combustion.CDtracking then
				mBI.db.global.spellAura.combustion.CDtracking = false
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Combustion CD tracking is disabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			else
				mBI.db.global.spellAura.combustion.CDtracking = true
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Combustion CD tracking is enabled")
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000Please reload your UI")
			end
		elseif t[1] == "print" then
			if	mBI.db.global.spellAura.livingBomb.enabled then
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Living Bomb tracking is enabled")
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Living Bomb tracking is disabled")
			end
			if mBI.db.global.spellAura.pyroblast.enabled then
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Pyroblast tracking is enabled")
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Pyroblast tracking is disabled")
			end
			if	mBI.db.global.spellAura.ffbolt.enabled then
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Frostfire Bolt tracking is enabled")
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Frostfire Bolt tracking is disabled")
			end
			if	mBI.db.global.spellAura.combustion.CDtracking then
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Combustion tracking is enabled")
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680Combustion tracking is disabled")
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680lb - to enable/disable tracking of " .. mBI.db.global.spellAura.livingBomb.locname .. " dot")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680pyro - to enable/disable tracking of " .. mBI.db.global.spellAura.pyroblast.locname .. " dot")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680ffb - to enable/disable tracking of " .. mBI.db.global.spellAura.ffbolt.locname .. " dot")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680combu - to enable/disable tracking of " .. mBI.db.global.spellAura.combustion.locname .. " CD")
			DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680print - prints the current dot tracking settings")
		end
	elseif t[0] == "help" then
		DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite v" .. mBIversion .. " | Istaran - Medivh EU")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi frame - Allow you to move or lock the frame")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi value - Set the two display thresholds")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi hide - Set wether mBI is automatically hidden in the absence of ignite damages on your target")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi spell - Enable or disable which spell to be tracked")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi reset - resets myBigIgnite settings to its default")
		DEFAULT_CHAT_FRAME:AddMessage("|cffFFE680/mbi help - this dialog")

	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite: " .. "|cffFFE680\"/mbi help\" for options")
	end
end


--Generate the frame
function myBigIgnite:CreateFrame()
	mBIframe, mBIEvents = CreateFrame("Frame", "mBIFrame", UIParent),{}
	local pos = mBI.db.global.mainFrame.position
	mBIframe:SetPoint(pos["POINT"], "UIParent", pos["RELATIVE"],pos["XCOORD"],pos["YCOORD"])
	mBIframe:SetFrameStrata("LOW")
	mBIframe:SetWidth(20)
	mBIframe:SetHeight(40)
	mBIframe:Show()
	if mBI.db.global.mainFrame.movable then
		myBigIgnite:MoveFrame()
	else
		myBigIgnite:MoveFrame()
	end
	
	mBIfcombat = CreateFrame("Frame", "mBIfcombat", mBIframe)
	mBIfcombat:SetPoint("CENTER", mBIframe, "CENTER", 0, 0)
	mBIfcombat:SetFrameStrata("LOW")
	mBIfcombat:SetWidth(0)
	mBIfcombat:SetHeight(0)
	mBIfcombat:SetMovable(false)
	mBIfcombat:EnableMouse(false)
	mBIfcombat:Hide()
	
	mBIframe.text = mBIframe:CreateFontString()
	mBIframe.text:SetPoint("RIGHT", mBIframe, "RIGHT", 0,0)
	mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	mBIframe.text:SetTextColor(1, 0.5, 0)
	mBIframe.text:SetText("0")
	if mBI.db.global.noIgHide then 
		mBIframe.text:Hide()
		mBIframe.text:SetText("0")
	end
	
	--texture = frame:CreateTexture()
	--texture:SetAllPoints(frame)
	--texture:SetTexture("Interface\\Addons\\myBigIgnite\\texture2.tga")
	--texture:SetVertexColor(1,.5,.15)

	DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite v"..mBIversion.. " loaded")
	if tonumber(mBI.db.global.igValue) == 0 then
		DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite: ".."|cffFFE680Your display threshold has not been set. Please use /mbi value to set the threshold")
	end
	
end


function myBigIgnite:CombatCheck(event,...)
	if (event == "PLAYER_REGEN_DISABLED") then
		mBIfcombat:Show()
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventHandler")
		mBI.igDmg = 0
		mBI.inCombat = true
	else
		mBI.inCombat = false
	end
end

 function myBigIgnite:LeaveCombat()
	mBIfcombat:Hide()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	mBI.igDmg = 0
	mBIframe.text:SetTextColor(1, 0.5, 0)
	mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	mBIframe.text:SetText(mBI.igDmg)
	if mBI.db.global.noIgHide then
		mBIframe.text:Hide()
	end
	if mBIwarning then
		DEFAULT_CHAT_FRAME:AddMessage("|cffFF8000myBigIgnite: ".."|cffFFE680Your display threshold has not been set. Please use \"/mbi value\" to set the threshold")
		UIErrorsFrame:AddMessage("|cffFF8000Your display threshold has not been set. Please use \"/mbi value\" to set the threshold")
	end
end

do
	local combuCDend, checkCD
	local timeBeforeStopReg = 5
	function myBigIgnite:OnUpdate(elapsed)
		self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed
		if (self.TimeSinceLastUpdate > mBIrefresh) then
			local time = GetTime()
			local dotNumber = 0
			for i = 1, #spellname do
				local name, _, _, _, _, duration, expTime, unitCaster, _, _, _ = UnitAura("target", spellname[i], nil, "PLAYER|HARMFUL")
				if spellenabled[i] then
					if (expTime ~= nil) then
						remainTime[i] = expTime - time
						if remainTime[i] <= 0 then
							remainTime[i] = 0
						end
					else
						remainTime[i] = 0
					end
					if remainTime[i] >= mBI.lag and mBI.dotForCombu[i] then
						dotNumber = dotNumber + 1
					end
					myBigIgnite:DBuffsDisplay(spellname[i], remainTime[i])
				end
				i = i+1
			end
			if (dotNumber == mBI.spellcount) then
				mBI.allDot = true
			else
				mBI.allDot = false
			end
			if mBI.db.global.spellAura.combustion.CDtracking then
				if mBI.combuCD then
					if mBI.combuCDdelay > 0 then
						mBI.combuCDdelay = mBI.combuCDdelay - mBIrefresh
						checkCD = false
					elseif mBI.combuCDdelay <= 0 and not checkCD then
						local startCD, durationCD, _ = GetSpellCooldown(mBI.db.global.spellAura.combustion.locname)
						combuCDend = startCD + durationCD
						checkCD = true
					end
					if combuCDend ~= nil then
						if time > combuCDend then
							mBI.combuCD = false
							combuCDend = nil
						end
					end
				end
			end
			myBigIgnite:TextHandler()
			if not mBI.inCombat and not mBI.combuCD then
				timeBeforeStopReg = timeBeforeStopReg - mBIrefresh
				if timeBeforeStopReg < 0 then
					myBigIgnite:LeaveCombat()
					timeBeforeStopReg = 5
				end
			end
			self.TimeSinceLastUpdate = 0
		end
	end
end	

function myBigIgnite:DBuffsDisplay(spellname, remaintime)
	if (spellname == mBI.db.global.spellAura.ignite.locname) then
		if (remaintime >= mBIrefresh) then
			mBIframe.text:Show()
			mBIframe.text:SetText(mBI.igDmg)
		else
			mBI.igDmg = 0
			mBIframe.text:SetTextColor(1, 0.5, 0)
			mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
			mBIframe.text:SetText(mBI.igDmg)
			if mBI.db.global.noIgHide then
				mBIframe.text:Hide()
			end
		end
	end
	
end
	

function myBigIgnite:TextHandler()
	local mBI_value, mBI_perct = tonumber(mBI.db.global.igValue), tonumber(mBI.db.global.igPerct)
	if (mBI.igDmg >= mBI_value) and mBI.allDot and not mBI.combuCD then 
		mBIframe.text:SetTextColor(0, 1, 0)
		mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
	elseif (mBI.igDmg >= mBI_value*mBI_perct) and mBI.allDot and not mBI.combuCD then
		mBIframe.text:SetTextColor(0.5, 0.5, 1)
		mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
	else 
		mBIframe.text:SetTextColor(1, 0.5, 0)
		mBIframe.text:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
	end
end	


	

-- Spell handler
function myBigIgnite:EventHandler(WOWevent, ...)
	if (mBI_value ~= 0) then
		local timestamp, eventtype, sourceGUID, sourcename, sourceflags, destGUID, destdame, destflags, spellID, spellname, spellschool, amount, overkill = ...
		local pGUID = UnitGUID("player")
		local tGUID = UnitGUID("target")
		if sourceGUID == pGUID and destGUID == tGUID then
			if string.find(eventtype, "_DAMAGE") and spellname == mBI.db.global.spellAura.ignite.locname then
				mBI.igDmg = amount
			elseif mBI.db.global.spellAura.combustion.CDtracking and (string.find(eventtype, "_CAST_SUCCESS") or string.find(eventtype, "_MISS")) and spellname == mBI.db.global.spellAura.combustion.locname then
				mBI.combuCD = true
				mBI.combuCDdelay = 0.5
			end
		end
	else
		mBIwarning = true
	end
end




-- enable/disable frame movement and register the position of mBIframe	
function myBigIgnite:MoveFrame()
	if mBI.db.global.mainFrame.movable then
		mBIframe:SetMovable(true)
		mBIframe:SetScript("OnMouseDown", function(mBIframe, button) 
			mBIframe.isMoving = true
			mBIframe:StartMoving()
		end)
		mBIframe:SetScript("OnMouseUp", function(mBIframe, button) 
				if (mBIframe.isMoving) then
					mBIframe.isMoving = nil
					mBIframe:StopMovingOrSizing()
					local p,rt,rp,x,y = mBIframe:GetPoint()
					local posi = {}
					posi["POINT"] = p
					posi["PARENT"] = "UIParent"
					posi["RELATIVE"] = rp
					posi["XCOORD"] = x
					posi["YCOORD"] = y
					mBI.db.global.mainFrame.position = posi
				end
				myBigIgnite.Frame = mBIframe
		end)
	else
		mBIframe:SetScript("OnMouseDown", function(mBIframe, button) 
			mBIframe.isMoving = nil
			mBIframe:StopMovingOrSizing()
		end)
		mBIframe:SetMovable(false)
	end
end

